import 'package:flutter/material.dart';

class CropWidget extends StatefulWidget {
  CropWidget({
    this.child,
    this.generalAlignment,
    this.verticalAlignment,
    this.horizontalAlignment,
    this.heightFactor,
    this.widthFactor,
  });

  final Widget child;
  final Alignment generalAlignment;
  final Alignment verticalAlignment;
  final Alignment horizontalAlignment;
  final double heightFactor;
  final double widthFactor;

  @override
  _CropWidgetState createState() => _CropWidgetState();
}

class _CropWidgetState extends State<CropWidget> {
  @override
  Widget build(BuildContext context) {
    return Container(
      child: Align(
        alignment: widget.generalAlignment,
        child: ClipRect(
          child: Container(
            child: Align(
              alignment: widget.horizontalAlignment,
              widthFactor: widget.widthFactor,
              heightFactor: 1.0,
              child: ClipRect(
                child: Container(
                  child: Align(
                    alignment: widget.verticalAlignment,
                    widthFactor: 1.0,
                    heightFactor: widget.heightFactor,
                    child: widget.child,
                  ),
                ),
              ),
            ),
          ),
        ),
      ),
    );
  }
}
